"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.runHandleMaterial = void 0;
const path = __importStar(require("path"));
const webpack_1 = require("../service/builder/webpack");
const copy_1 = require("../service/builder/copy");
const generate_1 = require("../service/builder/generate");
const util_1 = require("../util");
const types_1 = require("../../types");
function runHandleMaterial(appBuildDir, dependencies = [], materialsDir, runtime = types_1.RUNTIME.NONE, ignoreInstall = false) {
    return __awaiter(this, void 0, void 0, function* () {
        yield handleNormalMaterial({
            dependencies,
            materialsDir,
            appBuildDir,
            runtime,
            ignoreInstall,
        });
        yield handleCompositeComponent({ dependencies, appBuildDir });
    });
}
exports.runHandleMaterial = runHandleMaterial;
function handleNormalMaterial({ dependencies, materialsDir, appBuildDir, runtime, ignoreInstall, }) {
    return __awaiter(this, void 0, void 0, function* () {
        const timeTag = '-------------------- handleNormalMaterial';
        console.time(timeTag);
        const normalDependencies = dependencies.filter((item) => !item.isComposite);
        yield (0, webpack_1.downloadAndInstallDependencies)(normalDependencies, materialsDir, {
            runtime,
            ignoreInstall,
        });
        yield (0, copy_1.copyMaterialLibraries)(normalDependencies, materialsDir, appBuildDir);
        console.timeEnd(timeTag);
    });
}
function handleCompositeComponent({ dependencies, appBuildDir }) {
    return __awaiter(this, void 0, void 0, function* () {
        console.time('handleCompositeComponent');
        const compositeDependencies = dependencies.filter((item) => item.isComposite);
        const materialGroupInfoMap = {};
        dependencies.forEach((item) => (materialGroupInfoMap[item.name] = {
            isComposite: item.isComposite,
            version: item.version,
            entries: item.entries,
            schemaVersion: item.schemaVersion,
        }));
        const componentsMeta = yield (0, util_1.getComponentsInfo)(path.join(appBuildDir, 'src'), dependencies);
        yield (0, generate_1.writeLowCodeFilesForCompositeComp)(compositeDependencies, appBuildDir);
        yield (0, copy_1.genCompositeComponentLibraries)(compositeDependencies, appBuildDir, materialGroupInfoMap, componentsMeta);
        console.timeEnd('handleCompositeComponent');
    });
}
