import { Schema } from '@formily/react-schema-renderer';
import { IMaterialItem, IPageInstance, IListenerInstance, IComponentSchemaJson, IPluginInstance, IItemInstance, IWebRuntimeAppData, IComponentLibEntry } from '../../../weapps-core';
import { BuildType, IComponentsInfoMap } from '../../types/common';
import { DEPLOY_MODE } from '../../../types';
import { IOriginKeyInfo as IBaseOriginKeyInfo } from '../../../generator/core/generate';
export interface IOriginKeyInfo extends IBaseOriginKeyInfo {
}
export declare function generateAppStyleLessFile(allAppDataList: IWebRuntimeAppData[], appBuildDir: string): Promise<void>;
export declare function generateThemeVarsFile(themeVars: object | undefined, appBuildDir: string): Promise<void>;
export declare function generateAllPageJsxFile(pageInstanceList: IPageInstance[], appBuildDir: string, rootPath: string, dependencies: IMaterialItem[] | undefined, extraData: {
    isComposite: boolean;
    compProps: any;
} | undefined, buildTypeList: any[]): Promise<void>;
export declare function generateSinglePageJsxFile(pageInstance: IPageInstance, appBuildDir: string, rootPath: string, dependencies: IMaterialItem[] | undefined, extraData: {
    isComposite: boolean;
    compProps: any;
} | undefined, buildTypeList: any[]): Promise<void>;
export declare function getOriginComponentAndActionList(componentSchema: IComponentSchemaJson, fixedDependencies: IMaterialItem[], originComponentList?: IOriginKeyInfo[], originActionList?: IOriginKeyInfo[]): {
    originComponentList: IOriginKeyInfo[];
    originActionList: IOriginKeyInfo[];
};
export declare function getOriginPluginList(pluginInstances?: IPluginInstance[], dependencies?: IMaterialItem[], originPluginList?: IOriginKeyInfo[]): IOriginKeyInfo[];
interface IFixedDependence extends IMaterialItem {
    isPlainProps?: boolean;
    entries?: IComponentLibEntry;
}
export declare function pullActionToListByInstances(listenerInstances: any, originActionList: any, fixedDependencies: IFixedDependence[]): void;
export declare function pullComponentToListByInstance(sourceKey: string, originComponentList: IOriginKeyInfo[], fixedDependencies: IFixedDependence[]): void;
export declare function getVirtualFieldsString(components: IOriginKeyInfo[]): string;
export declare function isSlot(comp: Schema): boolean | "" | undefined;
export declare function getComponentSchemaString(componentSchema: IComponentSchemaJson, isComposite?: boolean, componentsInfoMap?: IComponentsInfoMap, wrapperClass?: string): {
    widgets: string;
    dataBinds: string;
    componentSchema: string;
};
export declare function getListenersString(listeners?: IListenerInstance[], isComposite?: boolean): string;
export declare function getPluginInstancesString(instances: IItemInstance[]): string;
export declare function getPluginImportStringArr(plugins: any, pluginImportStringArr?: string[]): string[];
export declare function getComponentImportStringArr(components: IOriginKeyInfo[], componentImportStringArr?: string[]): string[];
export declare function getEntryImportStringArr(materialInfoList?: {
    materialName: string;
    version: string;
    entries?: IComponentLibEntry;
}[], entryImportStringArr?: string[]): string[];
export declare function getActionImportStringArr(originActionList: IOriginKeyInfo[], actionImportStringArr?: string[]): string[];
export declare function pushActionToImportStringArr(listenerInstance: IOriginKeyInfo, actionImportStringArr: string[]): void;
export declare function generateRouterFile(allAppDataList: IWebRuntimeAppData[], appBuildDir: string, basename?: string, buildTypeList?: BuildType[]): Promise<void>;
export declare function writeLowCodeFiles(appData: IWebRuntimeAppData, appBuildDir: string): Promise<void>;
export declare function writeLowCodeFilesForCompositeComp(compositeGroups: IMaterialItem[], appBuildDir: string): Promise<void>;
export declare function generateCodeFromTpl(appData: IWebRuntimeAppData, appBuildDir: string, dependencies: IMaterialItem[], appKey: string, rootPath: any, deployMode: DEPLOY_MODE, buildTypeList: BuildType[], extraData: any): Promise<void>;
export {};
//# sourceMappingURL=generate.d.ts.map